# SDK Debug Telnet Console

{% content-ref url="/spaces/3UKy7VHRJWrNarYaMp13" %}
[Blippar Documentation Centre](https://docs.blippar.com/blippar-documentation-centre/)
{% endcontent-ref %}

The purpose of the following document is to introduce developers to the Blippar SDK Telnet Console. Telnet console is a very useful debugging instrument, that allows easily to collect logs from SDK debug log remotely as well as the information about currently open blipp. You can find out more about the available functionality in the Telnet console menu that is displayed in case the connection was successful.

## Starting Telnet Console Client in the Custom SDK App <a href="#blipparsdkdebugtelnetconsole-startingtelnetconsoleclientinthecustomsdkapp" id="blipparsdkdebugtelnetconsole-startingtelnetconsoleclientinthecustomsdkapp"></a>

To start the telnet console you can do the following from the SDK:

* **iOS - Objective C**

```
BOOL didStart = [BlipparSDK sharedInstance].debugConsole start];
```

* **Android - Java**

```
boolean didStart = Blippar.getSDK().getDebugConsole().start();
```

{% hint style="info" %}
In the rare case when the console fails to start, this normally means that there is a port conflict. Choose another port and try again. Make a note of the port, on iOS it is set to `23` by default and on Android it is set to `1123.`
{% endhint %}

## Connecting to the Telnet Console from Remote Client <a href="#blipparsdkdebugtelnetconsole-connectingtothetelnetconsolefromremoteclient" id="blipparsdkdebugtelnetconsole-connectingtothetelnetconsolefromremoteclient"></a>

* To connect to the running telnet console on the device you **must** be on the same network as the device. Find out what the IP of that device is in the device wifi settings.
* Now in Terminal (on OSX) type:`telnet`
* You will be presented with a menu screen that has a host of options, it operates just like regular telnet consoles.&#x20;
* At any point, type `menu` to get back to the main menu.
* As of OSX High Sierra (10.13.2), telnet is no longer bundled as part of the OS. You can download and install it manually or easily get it via homebrew: `brew install telnet`

## Blippar SDK Telnet Console Menu <a href="#blipparsdkdebugtelnetconsole-blipparsdktelnetconsolemenu" id="blipparsdkdebugtelnetconsole-blipparsdktelnetconsolemenu"></a>

* Type `menu` in the remote Telnet client to see the list of available commands. It may differ for different SDK builds and licenses, so some of the commands may be not available to you.
* All SDK instances allow to gather app and blipp logs through the Telnet console. By using the `log` command with different keys, listed in the console menu you can configure the amount of logs you will receive from the device.
* Please use  `menu` command to discover other options available to you with their detailed description provided in the telnet console menu.

## Stopping Telnet Console Client in the Custom SDK App <a href="#blipparsdkdebugtelnetconsole-stoppingtelnetconsoleclientinthecustomsdkapp" id="blipparsdkdebugtelnetconsole-stoppingtelnetconsoleclientinthecustomsdkapp"></a>

To stop the console again (this will disconnect your machine from the device) just the following:

**iOS - Objective C**

```
[[BlipparSDK sharedInstance].debugConsole stop];
```

**Android - Java**

```
Blippar.getSDK().getDebugConsole().stop();
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.blippar.com/blippbuilder-app-sdk/debugging-utilities/sdk-debug-telnet-console.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
